
class Vektor implements Cloneable // ohne Cloneable wuerde die Exception CloneNotSupportedException ausgeworfen
{   
	private final int length;
	private int[] data;
	public Vektor(int length)
	{
		this.length = length;
		data = new int[length];
	}
	public int getLength()
	{
		return length;
	}
	public int at(int i)
	{
		return data[i-1];
	}
	public void set(int i, int value)
	{
		data[i-1] = value;
	}
	public Object clone() //throws CloneNotSupportedException
	{
		Vektor o = new Vektor(this.length);
		for(int i = 0; i < length; ++i)
			o.data[i] = this.data[i];
		return o;
	}
}

class Clone_deep
{
	public final static int DIM = 5;
	public static void main(String[] args)
	{
		Vektor v = new Vektor(DIM);
		for(int i = 1; i <= DIM; ++i)
			v.set(i, i*i);

		Vektor m = (Vektor) v.clone();
		if(m == null) System.exit(1);
	
		for(int i = 1; i <= DIM; ++i)
			System.out.println(v.at(i));

		for(int i = 1; i <= DIM; ++i)
			m.set(i, -1);

		for(int i = 1; i <= DIM; ++i)
			System.out.println(v.at(i));

	}
}
