
class Vektor implements Cloneable // ohne Cloneable wuerde die Exception CloneNotSupportedException ausgeworfen
{   
	private final int length;
	private int[] data;
	public Vektor(int length)
	{
		this.length = length;
		data = new int[length];
	}
	public int getLength()
	{
		return length;
	}
	public int at(int i)
	{
		return data[i-1];
	}
	public void set(int i, int value)
	{
		data[i-1] = value;
	}
	public Object klonen() throws CloneNotSupportedException
	{
		return super.clone();
	}
}

class Clone_shallow
{
	public final static int DIM = 5;
	public static void main(String[] args)
	{
		Vektor v = new Vektor(DIM);
		for(int i = 1; i <= DIM; ++i)
			v.set(i, i*i);

		Vektor m = null;
		try
		{
			m = (Vektor) v.klonen();
		}
		catch(CloneNotSupportedException e) 
		{
			System.exit(1);
		}
		if(m == null) System.exit(1);
	
		for(int i = 1; i <= DIM; ++i)
			System.out.println(v.at(i));

		for(int i = 1; i <= DIM; ++i)
			m.set(i, -1);

		for(int i = 1; i <= DIM; ++i)
			System.out.println(v.at(i));

	}
}
