import java.lang.ClassCastException;
import java.util.Arrays;

class Vektor implements Cloneable, Comparable
{   
	private int[] data;
	public Vektor(int length)
	{
		data = new int[length];
	}
	public int getLength()
	{
		return data.length;
	}
	public int at(int i)
	{
		return data[i-1];
	}
	public void set(int i, int value)
	{
		data[i-1] = value;
	}
	public Object clone() //throws CloneNotSupportedException
	{
		Vektor o = new Vektor(this.data.length);
		for(int i = 0; i < this.data.length; ++i)
			o.data[i] = this.data[i];
		return o;
	}
	public String toString()
	{
		String s = "(";
		for(int i : data)
		{
			s += i;
			s += " ";
		}
		s += ")";
		return s;
	}
	protected void finalize() throws Throwable
	{
		data = null; // den GarbageCollector implizit aufrufen
	}
	public boolean equals(Object obj)
	{
		if(! (obj instanceof Vektor) ) return false;
		Vektor v = (Vektor) obj;
		if(v.data.length != this.data.length) return false;
		for(int i = 0; i < this.data.length; ++i)
			if(v.data[i] != this.data[i]) return false;
		return true;
	}
	public int compareTo(Object obj) throws ClassCastException
	{
		if(! (obj instanceof Vektor) ) throw new ClassCastException();
		Vektor v = (Vektor) obj;
		if(v.data.length != this.data.length) return (this.data.length < v.data.length) ? -1 : +1;
		for(int i = 0; i < this.data.length; ++i)
			if(v.data[i] != this.data[i]) return (this.data[i] < v.data[i]) ? -1 : +1;
		return 0;
	}

}

class CompareSort 
{
	public final static int DIM = 10;
	public static void main(String[] args)
	{
		Vektor [] arr = new Vektor[10];
		for(int i = 0; i < arr.length; ++i)
		{
			arr[i] = new Vektor(DIM);
			for(int j = 1; j <= DIM; ++j)
				arr[i].set(j, (int) ( Math.random()*8) );
		}
		
		for(Vektor v : arr)
			System.out.println(v);
		
		System.out.println("--");
		Arrays.sort(arr);

		for(Vektor v : arr)
			System.out.println(v);
	}
}
