import java.io.Externalizable;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;

class Vektor implements Externalizable
{
	private int[] data;
	public Vektor() // Externalizable muss Defaultkonstruktor haben!
	{
		
	}
	
	public Vektor(int length)
	{
		data = new int[length];
	}
	public int getLength()
	{
		return data.length;
	}
	public int at(int i)
	{
		return data[i-1];
	}
	public void set(int i, int value)
	{
		data[i-1] = value;
	}
	public String toString()
	{
		String s = "(";
		for(int i : data)
		{
			s += i;
			s += " ";
		}
		s += ")";
		return s;
	}
	@Override
	public void readExternal(ObjectInput in) throws IOException,ClassNotFoundException 
	{
		System.out.println("Lese Vektor");
		int dim = in.readInt();
		data = new int[dim];
		for(int i = 0; i < dim; ++i)
			data[i] = in.readInt();
	}
	@Override
	public void writeExternal(ObjectOutput out) throws IOException 
	{
		System.out.println("Schreibe Vektor");
		out.writeInt(data.length);
		for(int i : data) out.writeInt(i);
	}
}


public class External 
{
	final static int DIM = 20;
	public static void main(String[] args)
	{
		try
		{
			File f = new File("./dir");
			if(!f.exists() &&!f.mkdirs())
			{
				System.out.println("Kann Verzeichnis nicht anlegen");
				System.exit(1);
			}
			f = new File("./dir/datei.txt");
			if(!f.exists())
			{
				if(!f.createNewFile() || !f.canWrite())
				{
					System.out.println("Kann Datei nicht beschreiben!");
					System.exit(1);
				}
			
				Vektor v = new Vektor(DIM);
				for(int i = 1; i <= DIM; ++i)
					v.set(i, i*i);
			
				//System.out.println(v);

				ObjectOutputStream o = new ObjectOutputStream(new FileOutputStream(f));
				o.writeObject(v);
				o.close();
			}
			else
			{
				if(!f.canRead())
				{
					System.out.println("Kann Datei nicht anlegen/lesen");
					System.exit(1);
				}
				ObjectInputStream in = new ObjectInputStream(new FileInputStream(f));
				Vektor v = (Vektor)in.readObject();
				in.close();
				System.out.println(v);
				if(!f.delete())
				{
					System.out.println("Kann Datei nicht löschen");
					System.exit(1);
				}
			}

		} 
		catch(java.io.IOException e) { System.out.println(e);}
		catch(ClassNotFoundException e) {System.out.println(e);}
	}

}
