
class Vektor implements Cloneable // ohne Cloneable wuerde die Exception CloneNotSupportedException ausgeworfen
{   
	private int[] data;
	public Vektor(int length)
	{
		data = new int[length];
	}
	public int getLength()
	{
		return data.length;
	}
	public int at(int i)
	{
		return data[i-1];
	}
	public void set(int i, int value)
	{
		data[i-1] = value;
	}
	public Object clone() //throws CloneNotSupportedException
	{
		Vektor o = new Vektor(this.data.length);
		for(int i = 0; i < this.data.length; ++i)
			o.data[i] = this.data[i];
		return o;
	}
	public String toString()
	{
		String s = "(";
		for(int i : data)
		{
			s += i;
			s += " ";
		}
		s += ")";
		return s;
	}
	protected void finalize() throws Throwable
	{
		System.out.println("Finalize aufgerufen!");
		data = null; // den GarbageCollector implizit aufrufen
		System.gc(); // oder explizit
	}
}

class Finalize
{
	public final static int DIM = 5;
	public static void main(String[] args)
	{
		Vektor v = new Vektor(DIM);
		for(int i = 1; i <= DIM; ++i)
			v.set(i, i*i);

		Vektor m = (Vektor) v.clone();
		if(m == null) System.exit(1);
		// v loeschen:
		v = null;
		System.gc();
		try {	Thread.sleep(1000); } catch (InterruptedException e) {}

		System.out.println(m);

		for(int i = 1; i <= DIM; ++i)
			m.set(i, -1);

		System.out.println(m);

	}
}
