/* Der Cosinus hat zwischen 0 und π/2 einen Fixpunkt.
 * Dieses können wir berechnen - sogar mit dem Taschenrechner!
 * Starten wir bei einer Radiant-Zahl, z.B. 1rad und tippen diese in den Taschenrechner ein,
 * so können wir bei älteren Modellen durch wiederholtes Drücken der Cosinustaste erreichen, 
 * dass der Taschenrechner das zuletzt errechnete Ergebnis wieder verwendet. 
 * Man sieht, dass man irgendwann immer das gleiche Ergebnis erhält, also gibt es ein x, s.d. cos(x) = x
 */


class FixpunktCosinus
{
	// Wir lassen uns unserer Fixpunktfunktion einen Startwert übergeben, den wir x nennen
	static double fixpunkt(double x)
	{
		double p = Math.cos(x); // nun berechnen wir den Cosinus von x
		if(Math.abs(p-x) < 1e-4) return p; // Falls |x-p|<1e-4 nehmen wir an, dass x ungefähr p ist und beenden die Iteration
		return fixpunkt(p); // Ansonsten verwenden wir unser Ergebnis und "drücken erneut auf die Cosinus-Taste"
	}

	public static void main(String[] args)
	{
		System.out.println(fixpunkt(1));
	}
}
