interface Funktion {
	public double f(double x);
	public String name();
}

class Operation <T extends Funktion>
{
	public void operate(T op)
	{
		System.out.println(op.name());
		for(int i = 0; i < 10; ++i)
			System.out.println(op.f(i));
		System.out.println("--");
	}
}


class Generic_Class
{

	public static void main(String[] args)
	{
		class Id implements Funktion { // Identität
			public double f(double x)
			{
				return x;
			}
			public String name()
			{
				return "Identität";
			}
		}
		class Quadr implements Funktion { // quadratisch
			public double f(double x)
			{
				return x*x;
			}
			public String name()
			{
				return "Quadratisch";
			}
		}
		Operation<Quadr> o = new Operation<Quadr>();
		//Operation<Funktion> fo = o; // geht nicht!
		o.operate(new Quadr());
		new Operation<Id>().operate(new Id());
		ex(3.5);
	}
	public static void ex(double s)
	{
		final double konstante = s;
		class Konst implements Funktion { // konstant
			public double f(double x)
			{
				return konstante;
			}
			public String name()
			{
				return "Konstant";
			}
		}
		Operation<Funktion> o = new Operation<Funktion>();
		o.operate(new Konst());
	}
}
