interface Funktion {
	public double f(double x);
	public String name();
}

class Operation
{
	public static <T extends Funktion> void operate(T op)
	{
		System.out.println(op.name());
		for(int i = 0; i < 10; ++i)
			System.out.println(op.f(i));
		System.out.println("--");
	}
}


class Generic_Methoden
{

	public static void main(String[] args)
	{
		class Id implements Funktion { // Identität
			public double f(double x)
			{
				return x;
			}
			public String name()
			{
				return "Identität";
			}
		}
		class Quadr implements Funktion { // quadratisch
			public double f(double x)
			{
				return x*x;
			}
			public String name()
			{
				return "Quadratisch";
			}
		}
		Operation.operate(new Quadr());
		Operation.operate(new Id());
		ex(3.5);
	}
	public static void ex(double s)
	{
		final double konstante = s;
		class Konst implements Funktion { // konstant
			public double f(double x)
			{
				return konstante;
			}
			public String name()
			{
				return "Konstant";
			}
		}
		Operation.operate(new Konst());
	}
}
