class Liste
{
	public class Node
	{
		private Node next;
		public final double value;

		private Node(double value)
		{
			this.value = value;
		}
		public final Node getNext()
		{
			return next;
		}

		public final Node getFirst()
		{
			return Liste.this.first;
		}
		public final Node getLast()
		{
			return Liste.this.last;
		}
		public void add(double value) throws RuntimeException
		{
			if(next != null) throw new RuntimeException();
			Node o = new Node(value);
			this.next = o;
			Liste.this.last = o;
		}
	}
	private Node first = null;
	private Node last = null;
	
	public void add(double o)
	{
		if(first == null)
		{
			first = last = new Node(o);
			return;
		}
		Node t = new Node(o);
		last.next = t;
		last = t;
	}
	public final Node getFirst()
	{
		return first;
	}
	public final Node getLast()
	{
		return last;
	}
}

class Nested_Inner
{
	public static void main(String[] args)
	{
		Liste l = new Liste();
		for(int i = 0; i < 10; ++i)
			l.add(Math.sin(Math.PI * i/10.));
		Liste.Node n = l.getFirst();
		do
		{
			System.out.println(n.value);
		}
		while(( n = n.getNext()) != null);
		System.out.println("--");

		//n = n.getLast(); // schlecht, da n == null!
		n = l.getLast();
		try { n.add(Math.PI); } catch( RuntimeException e) { System.out.println(e); }
		n = n.getFirst();
		do
		{
			System.out.println(n.value);
		}
		while(( n = n.getNext()) != null);

	}
}
