
class Datenstruktur
{
	private static class Fehler extends Throwable
	{
		public Fehler() {}
	}
	public static interface Struktur
	{
		public int get(int index) throws Fehler;
		public void set(int index, int value) throws Fehler;
	}

	public static class Vektor implements Struktur
	{
		private int [] arr;
		public Vektor(int length)
		{
			arr = new int[length];
		}
		public int get(int index) throws Fehler
		{
			if(index < 0 || index >= arr.length) throw new Fehler();
			return arr[index];
		}
		public void set(int index, int value) throws Fehler
		{
			if(index < 0 || index >= arr.length) throw new Fehler();
			arr[index] = value;
		}
	}

	public Struktur s;

	Datenstruktur(Struktur s)
	{
		this.s = s;
	}
}

class Nested_Static
{
	final static int SIZE = 4;
	public static void main(String[] args)
	{
		Datenstruktur.Struktur s = new Datenstruktur.Vektor(SIZE);
		Datenstruktur d = new Datenstruktur(s);
		try
		{
			for(int i = 0; i < SIZE; ++i)
				d.s.set(i, i*i);
			for(int i = 0; i < SIZE; ++i)
				System.out.println(d.s.get(i));
		}
		catch(Throwable f) {} // kann nicht Fehler nehmen, da private!

	}
}
