import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.io.PrintStream;
import java.util.Observable;
import java.util.Observer;
import java.util.Scanner;


public class pipes {
	
	static class Lauscher extends Observable implements Runnable
	{
		Lauscher(PipedInputStream in)
		{
			this.in = in;
		}
		
		PipedInputStream in;

		@Override
		public void run() 
		{
			while(true)
			try 
			{
				while(in.available() > 0)
				{
					BufferedReader reader = new BufferedReader(new InputStreamReader(in));
					String s = reader.readLine();
					System.out.println("Lauscher hat gelauscht: " + s);
					if(s.length() > 0 && s.charAt(0) == 'q') return;
				}
				setChanged();
				notifyObservers(); // Gebe den Leser ein Zeichen
				Thread.sleep(3000);
			} 
			catch (Exception e) 
			{
				e.printStackTrace();
			}
		}
	}
	static class Leser implements Runnable, Observer
	{
		Leser(PipedOutputStream out)
		{
			this.out = out;
		}
		
		PipedOutputStream out;

		@Override
		public void run() 
		{
			Scanner s = new Scanner(System.in);
			PrintStream pr = new PrintStream(out);
			while(true)
			try 
			{
				while(System.in.available() > 0 && flushed)
				{
					if(!s.hasNext()) continue;
					String str = s.next();
					System.out.println("Leser hat gelesen: " + str);
					pr.println(str);
					flushed = false; // wenn wir zweimal neue Zeile ausgeben, wird der neue Inhalt nicht mehr in die Pipe kopiert -> wir muessen warten
					if(str.length() > 0 && str.charAt(0) == 'q')
						return;
				}
				Thread.sleep(100);
			} 
			catch (Exception e) 
			{
				e.printStackTrace();
			}	
		}
		boolean flushed = true;
		@Override
		public void update(Observable o, Object arg) 
		{
				flushed = true; // okay, der Lauscher ist fertig
		}
		
	}
	
	public static void main(String[] args) throws InterruptedException, IOException
	{
		PipedInputStream in = new PipedInputStream();
		PipedOutputStream out = new PipedOutputStream(in);
		Lauscher lauscher = new Lauscher(in);
		Leser leser = new Leser(out);
		Thread t1 = new Thread(lauscher);
		Thread t2 = new Thread(leser);
		lauscher.addObserver(leser);
		t1.start();
		t2.start();
		t1.join();
		t2.join();
		System.out.println("Programmende");
	}
}
