import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Scanner;


class Vektor implements Serializable
{   
	/**
	 * 
	 */
	private static final long serialVersionUID = 4396796128990768543L;
	private int[] data;
	public Vektor(int length)
	{
		data = new int[length];
	}
	public int getLength()
	{
		return data.length;
	}
	public int at(int i)
	{
		return data[i-1];
	}
	public void set(int i, int value)
	{
		data[i-1] = value;
	}
	public Object clone() //throws CloneNotSupportedException
	{
		Vektor o = new Vektor(this.data.length);
		for(int i = 0; i < this.data.length; ++i)
			o.data[i] = this.data[i];
		return o;
	}
	public String toString()
	{
		String s = "(";
		for(int i : data)
		{
			s += i;
			s += " ";
		}
		s += ")";
		return s;
	}
}

class Serialize
{
	final static int DIM = 20;
	public static void main(String[] args)
	{
		try
		{
			File f = new File("./dir");
			if(!f.exists() &&!f.mkdirs())
			{
				System.out.println("Kann Verzeichnis nicht anlegen");
				System.exit(1);
			}
			f = new File("./dir/datei.txt");
			if(!f.exists())
			{
				if(!f.createNewFile() || !f.canWrite())
				{
					System.out.println("Kann Datei nicht beschreiben!");
					System.exit(1);
				}
			
				Vektor v = new Vektor(DIM);
				for(int i = 1; i <= DIM; ++i)
					v.set(i, i*i);
			
				//System.out.println(v);

				ObjectOutputStream o = new ObjectOutputStream(new FileOutputStream(f));
				o.writeObject(v);
				o.close();
			}
			else
			{
				if(!f.canRead())
				{
					System.out.println("Kann Datei nicht anlegen/lesen");
					System.exit(1);
				}
				ObjectInputStream in = new ObjectInputStream(new FileInputStream(f));
				Vektor v = (Vektor)in.readObject();
				in.close();
				System.out.println(v);
				if(!f.delete())
				{
					System.out.println("Kann Datei nicht löschen");
					System.exit(1);
				}
			}

		} 
		catch(java.io.IOException e) {}
		catch(ClassNotFoundException e) {}
	}

}
