import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;


class Person implements Serializable
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 5767400587095423999L;
	final String name;
	transient final String passwort;
	Person(String name, String passwort)
	{
		this.name = name; this.passwort = passwort;
	}
	public String toString()
	{
		return "Name: " + name + ", Passwort: " + passwort; 
	}
}

public class Transient {
	public static void main(String[] args)
	{
		try
		{
			File f = new File("./dir");
			if(!f.exists() &&!f.mkdirs())
			{
				System.out.println("Kann Verzeichnis nicht anlegen");
				System.exit(1);
			}
			f = new File("./dir/datei.txt");
			if(!f.exists())
			{
				if(!f.createNewFile() || !f.canWrite())
				{
					System.out.println("Kann Datei nicht beschreiben!");
					System.exit(1);
				}
				
				Person p1 = new Person("Hans", "PikBube");
				Person p2 = new Person("Bertha", "HerzDame");

				ObjectOutputStream o = new ObjectOutputStream(new FileOutputStream(f));
				o.writeObject(p1);
				o.writeObject(p2);
				o.close();
			}
			else
			{
				if(!f.canRead())
				{
					System.out.println("Kann Datei nicht anlegen/lesen");
					System.exit(1);
				}
				ObjectInputStream in = new ObjectInputStream(new FileInputStream(f));
				Person p1 = (Person)in.readObject();
				Person p2 = (Person)in.readObject();
				in.close();
				System.out.println(p1);
				System.out.println(p2);
				if(!f.delete())
				{
					System.out.println("Kann Datei nicht löschen");
					System.exit(1);
				}
			}

		} 
		catch(java.io.IOException e) { System.out.println(e);}
		catch(ClassNotFoundException e) {System.out.println(e);}
	}
}
